/*
(the) SquirrelBox compiler v1.5.
Copyright (C) 2007 Dan Cook

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

import java.io.*;
import javax.swing.*;
import java.awt.event.*;

public abstract class HLz80gui
implements javax.swing.event.DocumentListener, ActionListener {
//GUI vars
	public javax.swing.filechooser.FileFilter adsFiles;
	public javax.swing.filechooser.FileFilter asmFiles;
	public javax.swing.filechooser.FileFilter txtFiles;
	public javax.swing.ImageIcon icon;
	public JTextArea[] asmOutput;
	public JFileChooser chooser;
	public JTabbedPane tpane;
	public boolean[] saved;
	public JRootPane root;
//Compiler vars
	private boolean stoppable;
	public String[] asmNames;
	public boolean[] asmUsed;
	public boolean loading;
	public String[] code;
	public function func;
	public int current;
	public Parser in;

	public static final int TI82 = 0;
	public static final int TI83 = 1;
	public static final int TI83_PLUS = 2;
	public static final int TI83_PLUS_SE = 3;
	public static final int TI84_PLUS = 4;
	public static final int TI84_PLUS_SE = 5;
	public static final int TI85 = 6;
	public static final int TI86 = 7;

	public void init(JRootPane r, boolean notApplet) {
		stoppable = false;
		saved = new boolean[0];
		asmNames = new String[] {
			"TI-82","TI-83","TI-83+","TI-83+ SE",
			"TI-84+","TI-84+ SE","TI-85","TI-86"
		}; asmUsed = new boolean[asmNames.length-1];
		asmOutput = new JTextArea[asmNames.length];
		code = new String[asmUsed.length];
		for(int i=0; i<asmOutput.length; i++) {
			asmOutput[i] = new JTextArea();
			asmOutput[i].setEditable(false);
			asmOutput[i].setFont(
				new java.awt.Font("Lucida Console",0,12)
			); asmOutput[i].setTabSize(4);
		} try {
			javax.swing.UIManager.setLookAndFeel(
				javax.swing.UIManager.getSystemLookAndFeelClassName()
			);
		} catch(Exception e){}
		icon = new ImageIcon("Squirrel.gif"); root = r;
		root.getContentPane().setLayout(new java.awt.GridBagLayout());
		JMenuBar menuBar = new JMenuBar();
		JMenu menu = new JMenu("File"); menu.setMnemonic('F');
		JMenuItem item = new JMenuItem("New", new ImageIcon("New.gif"));
		item.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_N, KeyEvent.CTRL_MASK)
		); item.setMnemonic('N'); item.setActionCommand("N");
		item.addActionListener(this); menu.add(item);
		if(notApplet) {
			item = new JMenuItem("Open", new ImageIcon("Open.gif"));
			item.setAccelerator(
				KeyStroke.getKeyStroke(KeyEvent.VK_O, KeyEvent.CTRL_MASK)
			); item.setMnemonic('O'); item.setActionCommand("O");
			item.addActionListener(this);
			menu.add(item);
		}
		item = new JMenuItem("Close", new ImageIcon("Close.gif"));
		item.setMnemonic('C'); item.setActionCommand("C");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("Close All", new ImageIcon("Close All.gif"));
		item.setMnemonic('E'); item.setActionCommand("E");
		item.addActionListener(this); menu.add(item);
		if(notApplet) {
			menu.addSeparator();
			item = new JMenuItem("Save", new ImageIcon("Save.gif"));
			item.setAccelerator(
				KeyStroke.getKeyStroke(KeyEvent.VK_S, KeyEvent.CTRL_MASK)
			); item.setMnemonic('S'); item.setActionCommand("S");
			item.addActionListener(this); menu.add(item);
			item = new JMenuItem("Save As", new ImageIcon("Save.gif"));
			item.setMnemonic('A'); item.setActionCommand("A");
			item.addActionListener(this); menu.add(item);
			item = new JMenuItem("Save All", new ImageIcon("Save All.gif"));
			item.setMnemonic('L'); item.setActionCommand("L");
			item.addActionListener(this); menu.add(item);
			menu.addSeparator();
			item = new JMenuItem("Exit", new ImageIcon("Exit.gif"));
			item.setAccelerator(
				KeyStroke.getKeyStroke(KeyEvent.VK_Q, KeyEvent.CTRL_MASK)
			); item.setMnemonic('X'); item.setActionCommand("X");
			item.addActionListener(this); menu.add(item);
			/*root.addKeyListener(new KeyAdapter() {
				public void keyPressed(KeyEvent k) {
					if(k.getKeyCode() == KeyEvent.VK_ESCAPE) {
						if(stoppable) throw new StopCompiling();
					}
				}
			});*/
		} menuBar.add(menu);
		menu = new JMenu("Build"); menu.setMnemonic('B');
		item = new JMenuItem("Compile", new ImageIcon("Compile.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F7, 0));
		item.setMnemonic('C'); item.setActionCommand("M");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("Stop Compiling", new ImageIcon("Stop.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0));
		item.setMnemonic('S'); item.setActionCommand("Z");
		item.addActionListener(this); menu.add(item);
		menuBar.add(menu);
		menu = new JMenu("Show Output"); menu.setMnemonic('S');
		item = new JMenuItem("TI-82", new ImageIcon("calc.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2, 0));
		item.setMnemonic('2'); item.setActionCommand("2");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-83", new ImageIcon("calc.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3, 0));
		item.setMnemonic('3'); item.setActionCommand("3");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-83 Plus", new ImageIcon("calc.gif"));
		item.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_F3, KeyEvent.ALT_MASK)
		); item.setMnemonic('P'); item.setActionCommand("P");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-83+ SE", new ImageIcon("calc.gif"));
		item.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_F3, KeyEvent.SHIFT_MASK)
		); item.setMnemonic('S'); item.setActionCommand("T");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-84 Plus", new ImageIcon("calc.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, 0));
		item.setMnemonic('4'); item.setActionCommand("4");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-84+ SE", new ImageIcon("calc.gif"));
		item.setAccelerator(
			KeyStroke.getKeyStroke(KeyEvent.VK_F4, KeyEvent.SHIFT_MASK)
		); item.setMnemonic('E'); item.setActionCommand("I");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-85", new ImageIcon("calc.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0));
		item.setMnemonic('5'); item.setActionCommand("5");
		item.addActionListener(this); menu.add(item);
		item = new JMenuItem("TI-86", new ImageIcon("calc.gif"));
		item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F6, 0));
		item.setMnemonic('6'); item.setActionCommand("6");
		item.addActionListener(this); menu.add(item);
		menuBar.add(menu);
		menu = new JMenu("Help"); menu.setMnemonic('H');
		item = new JMenuItem("About", new ImageIcon("About.gif"));
		item.setMnemonic('A'); item.setActionCommand("B");
		item.addActionListener(this); menu.add(item);
		menuBar.add(menu); root.setJMenuBar(menuBar);
		Box box = new Box(BoxLayout.X_AXIS);
		box.add(Box.createHorizontalStrut(5));
		JButton button = new JButton(new ImageIcon("New.gif"));
		button.setToolTipText("New"); button.setActionCommand("N");
		button.addActionListener(this); box.add(button);
		if(notApplet) {
			box.add(Box.createHorizontalStrut(5));
			button = new JButton(new ImageIcon("Open.gif"));
			button.setToolTipText("Open"); button.setActionCommand("O");
			button.addActionListener(this); box.add(button);
			box.add(Box.createHorizontalStrut(20));
			button = new JButton(new ImageIcon("Save.gif"));
			button.setToolTipText("Save"); button.setActionCommand("S");
			button.addActionListener(this); box.add(button);
			box.add(Box.createHorizontalStrut(5));
			button = new JButton(new ImageIcon("Save All.gif"));
			button.setToolTipText("Save All"); button.setActionCommand("L");
			button.addActionListener(this); box.add(button);
		} box.add(Box.createHorizontalStrut(20));
		button = new JButton(new ImageIcon("Close.gif"));
		button.setToolTipText("Close"); button.setActionCommand("C");
		button.addActionListener(this); box.add(button);
		box.add(Box.createHorizontalStrut(5));
		button = new JButton(new ImageIcon("Close All.gif"));
		button.setToolTipText("Close All"); button.setActionCommand("E");
		button.addActionListener(this); box.add(button);
		box.add(Box.createHorizontalStrut(20));
		button = new JButton(new ImageIcon("Compile.gif"));
		button.setToolTipText("Compile"); button.setActionCommand("M");
		button.addActionListener(this); box.add(button);
		box.add(Box.createHorizontalStrut(5));
		button = new JButton(new ImageIcon("Stop.gif"));
		button.setToolTipText("Stop Compiling"); button.setActionCommand("Z");
		button.addActionListener(this); box.add(button);
		if(notApplet) {
			box.add(Box.createHorizontalStrut(20));
			button = new JButton(new ImageIcon("Exit.gif"));
			button.setToolTipText("Exit (Duh!)"); button.setActionCommand("X");
			button.addActionListener(this); box.add(button);
		} box.add(Box.createHorizontalStrut(20));
		box.add(Box.createHorizontalGlue());
		button = new JButton(new ImageIcon("About.gif"));
		button.setToolTipText("About SquirrelBox"); button.setActionCommand("B");
		button.addActionListener(this); box.add(button);
		box.add(Box.createHorizontalStrut(5));
		root.getContentPane().add(
			box, new java.awt.GridBagConstraints(
				0, 0, 1, 1, 0, 0,
				java.awt.GridBagConstraints.WEST,
				java.awt.GridBagConstraints.HORIZONTAL,
				new java.awt.Insets(0,0,0,0), 0, 0
			)
		); if(notApplet) {
			chooser = new JFileChooser();
			chooser.setCurrentDirectory(
				new File("HLz80compiler.class")
			);
			chooser.setMultiSelectionEnabled(false);
			txtFiles = new javax.swing.filechooser.FileFilter() {
				public boolean accept(File f) {
					String name = f.getName();
					return
						name.indexOf(".txt") == name.length()-4 ||
						name.indexOf('.') == -1;
				}
				public String getDescription() {
					return "Text files (.txt)";
				}
			};
			chooser.addChoosableFileFilter(txtFiles);
			asmFiles = new javax.swing.filechooser.FileFilter() {
				public boolean accept(File f) {
					String name = f.getName();
					return
						name.indexOf(".z80") == name.length()-4 ||
						name.indexOf(".asm") == name.length()-4 ||
						name.indexOf('.') == -1;
				}
				public String getDescription() {
					return "z80 Assembly files (.z80 .asm)";
				}
			};
			chooser.addChoosableFileFilter(asmFiles);
			adsFiles = new javax.swing.filechooser.FileFilter() {
				public boolean accept(File f) {
					String name = f.getName();
					return
						name.indexOf(".ads") == name.length()-4 ||
						name.indexOf('.') == -1;
				}
				public String getDescription() {
					return "Antidisassemblage files (.ads)";
				}
			}; chooser.setFileFilter(adsFiles);
		} tpane = new JTabbedPane(SwingConstants.BOTTOM);
		root.getContentPane().add(
			tpane, new java.awt.GridBagConstraints(
				0, 1,
				java.awt.GridBagConstraints.REMAINDER,
				java.awt.GridBagConstraints.REMAINDER, 1, 1,
				java.awt.GridBagConstraints.CENTER,
				java.awt.GridBagConstraints.BOTH,
				new java.awt.Insets(5,5,5,5), 5, 5
			)
		);
	}

	public int tabsAfter(int tab) {
		int tabs = 0;
		for(int i=tab+1; i<asmNames.length; i++) {
			if(tpane.indexOfTab(asmNames[i]) != -1) tabs++;
		} return tabs;
	}

	public int asmtabs() {
		return tabsAfter(-1);
	}

	public boolean valid(String name) {
		for(int i=0; i<asmNames.length; i++)
			if(name.equals(asmNames[i]))
				return false;
		return true;
	}

	public boolean isSaved(int index) {
		String name = tpane.getTitleAt(index);
		return name.indexOf(" *") != name.length()-2;
	}

	public String fix(String name) {
		int index = name.indexOf(" *");
		if(index == name.length()-2 && index >= 0)
			return name.substring(0, name.length()-2);
		return name;
	}

	public void close() {
		try {
			int index = tpane.getSelectedIndex();
			String name = tpane.getTitleAt(index);
			if(name.indexOf(" *") == name.length()-2) {
				if(Confirm("Save changes to "+name+'?'))
					saveAs(index);
			}
			if(valid(tpane.getTitleAt(index))) {
				boolean[] remove = new boolean[saved.length-1];
				for(int i=0; i<remove.length; i++)
					remove[i] = saved[i];
				saved = remove;
			}
			tpane.removeTabAt(index);
		} catch(Throwable t){uhoh(t);}
	}

	public void save(int tab, String name, boolean overwrite) {
		try {
			name = fix(name);
			boolean asm = tab >= saved.length;
			if(!valid(name)) {
				if(asm) Message(
					"You cannot name a file \""+name+"\" because it\n" +
					"is reserved for the "+name+" compiler output"
				); else Message(
					"You must specify a file name for the\n" +
					name+" output other than "+name
				); saveAs(tab);
				return;
			} if(!overwrite && name.indexOf("Untitled") == 0) {
				saveAs(tab); return;
			} if(
				asm &&
				(name.indexOf(".asm") < 0) &&
				(name.indexOf(".z80") < 0)
			) name += ".z80";
			else if(name.indexOf('.') < 0) name += ".ads";
			try {
				new DataOutputStream(
					new FileOutputStream(
						new File(chooser.getCurrentDirectory(), name)
					)
				).writeBytes(getTextArea(tab).getText());
				if(!asm) {
					tpane.setTitleAt(tab, name);
					saved[tab] = true;
				}
			}
			catch(IOException e) {
				if(!saved[tab]) {
					String Retry = "Retry";
					if(
						JOptionPane.YES_OPTION !=
						JOptionPane.showOptionDialog(
							root,
							"Error saving to "+name,
							"SquirrelBox v1.4",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.ERROR_MESSAGE,
							icon,
							new String[]{Retry,"Cancel"},
							Retry
						)
					) return;
				}
				saveAs(tab);
			}
		} catch(Throwable t){uhoh(t);}
	}

	public void save(int tab) {
		save(tab, tpane.getTitleAt(tab), false);
	}

	public void saveAs(int tab) {
		try {
			boolean asm = !valid(tpane.getTitleAt(tab));
			if(asm) chooser.setFileFilter(asmFiles);
			else chooser.setFileFilter(adsFiles);
			if(
				JFileChooser.APPROVE_OPTION ==
				chooser.showSaveDialog(root)
			) {
				File file = chooser.getSelectedFile();
				if(file.getName().indexOf('.') < 0) {
					if(asm) file = new File(file.getAbsolutePath()+".z80");
					else file = new File(file.getAbsolutePath()+".ads");
				} if(file.exists()) {
					String Rename = "Rename";
					switch(
						JOptionPane.showOptionDialog(
							root,
							"There is already a file named "+file.getName(),
							"SquirrelBox v1.4",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.WARNING_MESSAGE,
							icon,
							new String[]{Rename,"Overwrite","Cancel"},
							Rename
						)
					) {
						case JOptionPane.NO_OPTION: break;
						case JOptionPane.YES_OPTION: saveAs(tab);
						default: return;
					}
				} if(!asm) tpane.setTitleAt(
					tab, chooser.getSelectedFile().getName()
				); save(tab, file.getName(), true);
			}
		} catch(Throwable t){uhoh(t);}
	}

	public void saveAll() {
		for(int i=0; i<tpane.getTabCount(); i++)
			if(valid(tpane.getTitleAt(i))) save(i);
	}

	public void exit() {
		if(
			JOptionPane.YES_OPTION ==
			JOptionPane.showConfirmDialog(
				root,
				"Exit HLz80 SquirrelBox?",
				"SquirrelBox v1.4",
				JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				icon
			)
		) {
			String name;
			for(int i=0; i<saved.length; i++) {
				name = tpane.getTitleAt(i);
				if(name.indexOf(" *") == name.length()-2) {
					switch(
						JOptionPane.showConfirmDialog(
							root,
							"Save changes before Exiting?",
							"SquirrelBox v1.4",
							JOptionPane.YES_NO_CANCEL_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							icon
						)
					) {
						case JOptionPane.YES_OPTION: saveAll();
						case JOptionPane.NO_OPTION: break;
						default: return;
					} break;
				}
			} System.exit(0);
		}
	}

	public void show(int tab, boolean clear) {
		try {
			int index = tpane.getTabCount()-tabsAfter(tab);
			int place = tpane.indexOfTab(asmNames[tab]);
			if(place == -1) {
				tpane.insertTab(
					asmNames[tab],
					new ImageIcon("calc.gif"),
					new JScrollPane(
						asmOutput[tab],
						JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
						JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED
					), "Compiled "+asmNames[tab]+" Output Code", index
				); tpane.setSelectedIndex(index);
			} else tpane.setSelectedIndex(place);
			if(clear) asmOutput[tab].setText("");
		} catch(Throwable t){uhoh(t);}
	}

	public void show(int tab) {
		show(tab, false);
	}

	public JTextArea getTextArea(int index) {
		return (JTextArea)(
			((JScrollPane)tpane.getComponentAt(index)
			).getViewport().getView()
		);
	}

	public boolean addTab(String title, boolean s) {
		try {
			int index = tpane.indexOfTab(fix(title));
			if(index != -1) {
				if(Confirm(title+" is already open; replace it?")) {
					saved[index] = s;
					tpane.setSelectedIndex(index);
					getTextArea(index).requestFocus();
					return true;
				} else return false;
			} JTextArea area = new JTextArea();
			area.setFont(new java.awt.Font("Lucida Console",0,12));
			area.getDocument().addDocumentListener(this);
			area.setTabSize(4);
			//index = -asmtabs();
			Icon ico = null;
			String tip = null;
			if(title.indexOf(".ads") >= 0) {
				tip = "ADSMBLG Source File";
				ico = new ImageIcon("ads.gif");
			} else if(title.indexOf(".txt") >= 0) {
				tip = "Text File";
				ico = new ImageIcon("txt.gif");
			} else if(title.indexOf(".z80")>=0 || title.indexOf(".asm")>=0) {
				tip = "z80 Assembly Source File";
				ico = new ImageIcon("z80.gif");
			} else {
				boolean fail = true;
				for(int i=0; fail && i<asmNames.length; i++) {
					if(title.equals(asmNames[i])) {
						tip = "Compiled "+asmNames[i]+" Output Code";
						fail = false; ico = new ImageIcon("calc.gif");
					}
				} if(fail) {
					tip = "Unrecognized File";
					ico = new ImageIcon("about.gif");
				}
			} tpane.insertTab(
				title, ico,
				new JScrollPane(
					area,
					JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
					JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED
				), tip, saved.length//+index
			); tpane.setSelectedIndex(tpane.indexOfTab(title));
			if(valid(title)) {
				boolean[] add = new boolean[saved.length+1];
				for(int i=0; i<saved.length/*+index*/; i++)
					add[i] = saved[i];
				//add[saved.length+index] = add[saved.length];
				saved = add;
			} area.requestFocus();
		} catch(Throwable t){uhoh(t);}
		return true;
	}

	public void asmOut(String code) {
		if(loading) return;
		show(current);
		asmOutput[current].setText(asmOutput[current].getText()+code);
	}

	public void asmOutln(String code) {
		asmOut(code+'\n');
	}

	public void asmOutln() {
		asmOut("\n");
	}

	private String shorten(String string) {
		if(string.length() > 750)
			return string.substring(0,747)+"...";
		int count = 0;
		for(int i=0; i<string.length(); i++) {
			if(string.charAt(i) == '\n') {
				if(++count > 15) return string.substring(0,i)+"...";
			}
		} return string;
	}

	public void Error(String message, String code, boolean print)
	throws CompileError {
		if(code != null) message += "\nFound: "+code;
		if(print) {
			CompileError ce = new CompileError();
			StringWriter stacktrace = new StringWriter();
			ce.printStackTrace(new PrintWriter(stacktrace));
			JOptionPane.showMessageDialog(
				root, "ERROR MESSAGE:\n"+message+"\n\nCODE FOLLOWING ERROR:\n"
				+in.stack+"\n\nSTACK TRACE:\n"+shorten(stacktrace.toString()),
				"SquirrelBox v1.4 (CompileError)", JOptionPane.ERROR_MESSAGE, icon
			); throw ce;
		}
		JOptionPane.showMessageDialog(
			root, message, "SquirrelBox v1.4 CompileError",
			JOptionPane.ERROR_MESSAGE, icon
		);
	}

	public void Error(String message, String code) throws CompileError {
		Error(message, code, true);
	}

	public void Error(String message) throws CompileError {
		Error(message, null);
	}

	public void Warning(String message) throws CompileError {
		String ok = "Coninue";
		if(
			JOptionPane.OK_OPTION !=
			JOptionPane.showOptionDialog(
				root, "Warning:\n"+message, "SquirrelBox v1.4",
				JOptionPane.OK_CANCEL_OPTION,
				JOptionPane.WARNING_MESSAGE,
				icon, new String[]{ok,"Stop"}, ok
			)
		) throw new CompileError();
	}

	public void Message(String message) {
		JOptionPane.showMessageDialog(
			root, message, "SquirrelBox v1.4",
			JOptionPane.PLAIN_MESSAGE, icon
		);
	}

	public boolean Confirm(String message) {
		return JOptionPane.YES_OPTION ==
			JOptionPane.showConfirmDialog(
				root, message, "SquirrelBox v1.4",
				JOptionPane.YES_NO_OPTION,
				JOptionPane.PLAIN_MESSAGE, icon
			);
	}

	private void uhoh(Throwable thrown) {
		StringWriter stacktrace = new StringWriter();
		thrown.printStackTrace(new PrintWriter(stacktrace));
		String report = stacktrace.toString();
		JOptionPane.showMessageDialog(
			root,
			"An unexpected Error occurred. SquirrelBox will be terminated\n" +
			"and you will lose all unsaved data. Please record the following\n" +
			"and report it to me so I can try to fix the problem (press [ALT]+\n" +
			"[Print Screen] to copy an image of this and send me the image)\n\n" +
			shorten(report), "SquirrelBox v1.4 (Unexpected Error!)",
			JOptionPane.ERROR_MESSAGE, icon
		);
		System.exit(0);
	}

	public void doCompile() {
		try {
			if(saved.length<1) {
				Message("There is nothing to compile, genius");
				return;
			} int index = tpane.getSelectedIndex();
			String name = tpane.getTitleAt(index);
			if(!valid(name)) JOptionPane.showMessageDialog(
				root,
				"You cannot compile the "+name+" output tab"+
				"because it is reserved for the "+name+" output",
				"SquirrelBox v1.4", JOptionPane.WARNING_MESSAGE, icon
			); else if(name.indexOf(".z80")>=0 || name.indexOf(".asm")>=0) {
				JOptionPane.showMessageDialog(
					root,
					"You cannot compile z80 assembly files because\n" +
					"HLz80 SquirrelBox compiles antidisassemblage\n" +
					"programs into z80 assembly files. To compile\n" +
					"a z80 assembly file, you need a z80 assembly\n" +
					"compiler (I reccomend TASM, which can be found\n" +
					"at http://ticalc.org).",
					"SquirrelBox v1.4", JOptionPane.WARNING_MESSAGE, icon
				);
			} else {
				saveAll(); func = null;
				asmUsed = new boolean[asmUsed.length];
				String[] texts = new String[asmOutput.length];
				for(int i=0; i<asmOutput.length; i++)
					texts[i] = asmOutput[i].getText();
				boolean success = false;
				try{
					stoppable = true;
					try {
						in = new Preprocessor(
							tpane.getTitleAt(index),
							getTextArea(index).getText(),
							this
						); ((Preprocessor)in).preprocess();
						success = true;
					} catch(CompileError c) {
						Error(
							"Compilation stopped by the preprocessor\n",
							null, false
						);
					} if(success) compile();
					stoppable = false;
				} catch(StopCompiling s) {
					stoppable = false;
					for(int i=0; i<asmOutput.length; i++)
						asmOutput[i].setText(texts[i]);
					Message(
						"Compilataion stopped by the user. All assembly\n" +
						"output has been restored to its previous state"
					);
				}
			}
		} catch(Throwable t){uhoh(t);}
	}

	public void insertUpdate(javax.swing.event.DocumentEvent d) {
		tpane.setTitleAt(
			tpane.getSelectedIndex(),
			fix(tpane.getTitleAt(tpane.getSelectedIndex()))+" *"
		);
	}

	public void removeUpdate(javax.swing.event.DocumentEvent d) {
		insertUpdate(d);
	}

	public abstract void compile();
	public void changedUpdate(javax.swing.event.DocumentEvent d){}

	public void actionPerformed(ActionEvent a) {
		switch(a.getActionCommand().charAt(0)) {
		  case 'N':
			int next;
			String ut = "Untitled";
			for(
				next = 1;
				tpane.indexOfTab(ut+Integer.toString(next)+".ads") >= 0 ||
				tpane.indexOfTab(ut+Integer.toString(next)+".ads *") >= 0;
				next++
			); addTab(ut+Integer.toString(next)+".ads *", false);
			getTextArea(tpane.getSelectedIndex()).setText("");
			return;
		  case 'O':
			chooser.setMultiSelectionEnabled(true);
			if(chooser.APPROVE_OPTION == chooser.showOpenDialog(root)) {
				File[] files = chooser.getSelectedFiles();
				int index;
				String name;
				JTextArea area;
				for(int i=0; i<files.length; i++) {
					name = files[i].getName();
					if(!valid(name))
						Message("You cannot open a file called "+name);
					else {
						if(addTab(name, true)) {
							try {
								area = getTextArea(
									tpane.indexOfTab(name)
								); area.read(
									new BufferedReader(
										new FileReader(files[i])
									), null
								); area.getDocument().addDocumentListener(this);
								area.setTabSize(4);
							} catch(FileNotFoundException f) {
								Error("\""+name+"\" not found");
							} catch(IOException e) {
								Error("Error reading from "+name);
							}
						}
					}
				} for(int i=files.length-1; i>=0; i--) {
					index = tpane.indexOfTab(files[i].getName());
					if(index != -1) tpane.setSelectedIndex(index);
				}
			} chooser.setMultiSelectionEnabled(false); return;
		  case 'C': if(tpane.getTabCount() > 0) close(); return;
		  case 'E': while(tpane.getTabCount() > 0) close(); return;
		  case 'S':
			if(tpane.getTabCount() > 0) save(tpane.getSelectedIndex()); return;
		  case 'A':
			if(tpane.getTabCount()>0) saveAs(tpane.getSelectedIndex()); return;
		  case 'L': saveAll(); return;
		  case 'X': exit(); return;
		  case 'M': doCompile(); return;
		  case 'Z': if(stoppable) throw new StopCompiling(); return;
		  case '2': show(TI82); return;
		  case '3': show(TI83); return;
		  case 'P': show(TI83_PLUS); return;
		  case 'T': show(TI83_PLUS_SE); return;
		  case '4': show(TI84_PLUS); return;
		  case 'I': show(TI84_PLUS_SE); return;
		  case '5': show(TI85); return;
		  case '6': show(TI86); return;
		  case 'B': Message(
"(the) SquirrelBox compiler v1.4.\n"+
"Copyright (C) 2005 Dan Cook\n\n"+

"SquirrelBox is the compiler that I made for the \"Antidisassemblage\" programming\n"+
"language that I Designed with some help of various other people as a group formally\n"+
"known as the \"High Level z80\" project (which was the temporary name of the language).\n\n"+
					
"Antidisassemblage (or adsmblg for short) is a high-level programming language that is\n"+
"similar to C++ and Java (but much smaller and simpler) (it also has some alternate TI-BASIC-\n"+
"like syntax) designed for z80 graphing calculators (all TI models from the TI-82 to the TI-86\n"+
"inclusive) (everything compiles into z80 assembly source code). I designed all of this so that\n"+
"people can write assembly quality programs without having to know assembly.\n\n"+

"The language can be customized to do anything that can be done in assembly by designing\n"+
"assembly macros and making \"libraries\" of include include files (source files that contain reusable\n"+
"antidisassemablage (and assembly) code). It can even be made to work for/with assembly shells,\n"+
"routine libraries, APPS, etc. or any other thing at all that can have other assembly stuff made for\n"+
"it. See the [included] tutorials for more information on how to use the antidisassemablge language.\n\n"+

"Also, I would like to thank Jack Crenshaw for writing those \"Let's make a compiler tutorials which\"\n"+
"were a major help for me in developing the compiler (they gave me a lot of great ideas such as using\n"+
"a recursive-decent pattern to parse through code dynamically without having to exlicitly use stacks\n"+
"in order to keep track everything and all that kind of stuff).\n\n"+

"The Antidisassemblage language has a lot of room to grow (it's a brand new language), so\n"+
"if you are interested in helping develop include files and/or assembly macros and all that good\n"+
"stuff (and help the Antidisassemblage programming community grow), please visit this website:\n"+
"http://groups.yahoo.com/group/Antidisassemblage/"
		  ); default: return;
		}
	}
}